from .constants import MIN_screen_capacity, MAX_screen_capacity, MIN_screen_resolution, MAX_screen_resolution, MIN_screen_size, MAX_screen_size

class Screen(object):
    """_summary_

    Args:
        object (_type_): _description_
    """
    def __init__(self, id:int, capacity:int=0, sizeH:int=0, sizeW:int=0, resolutionH:float=0.0, resolutionW:float=0.0, isIMAX:bool=False) -> None:
        self.id = id
        self.capacity:int = capacity
        self.screenSizeHeight:int = sizeH
        self.screenSizeWidth:int = sizeW
        self.screenResolutionHeight = resolutionH
        self.screenResolutionWidth = resolutionW
        self.isIMAX:bool = isIMAX
        
    def __str__(self) -> str:
        return f"Screen(id={self.id}, capacity={self.capacity}, screenSize={self.screenSize}, screenResolution={self.screenResolution}, isIMAX={self.isIMAX})"
        
    @property
    def screenSize(self) -> str:
        return f"{self.screenSizeWidth}x{self.screenSizeHeight}m"
    @property
    def screenResolution(self) -> str:
        return f"{self.screenResolutionWidth}x{self.screenResolutionHeight}p"
    
    # Getters, inherited from Object class
    # Setters
    def set_capacity(self, value:int) -> None:
        if MIN_screen_capacity >= value >= MAX_screen_capacity:
            self.capacity = value
        else:
            # log
            print(f"Error; input({value}) out of range {MIN_screen_capacity}-{MAX_screen_capacity}.")
        
    def set_screen_size(self, height:float, width:float) -> None:
        if MIN_screen_size >= height >= MAX_screen_size or MIN_screen_size >= width >= MAX_screen_size:
            self.screenSizeHeight = float(height)
            self.screenSizeWidth = float(width)
        else:
            # log
            print(f"Error, input values:{height}m, {width}m out of bounds {MIN_screen_size}-{MAX_screen_size}m")

    def set_screen_resolution(self, height:int, width:int) -> None:
        if MIN_screen_resolution >= height >= MAX_screen_resolution or MIN_screen_resolution >= width >= MAX_screen_resolution:
            self.screenSizeHeight = height
            self.screenSizeWidth = width
        else:
            # log
            print(f"Error, input values:{width}x{height}p out of bounds {MIN_screen_resolution}-{MAX_screen_resolution}")



if __name__ == "__main__":
    # testing
    test = Screen()
    print(test)